import gleam/bool
import gleam/io
import gleam/result
import space_packet/primary_hdr

pub fn main() {
  let space_packet_pri_hdr =
    primary_hdr.PrimaryHeader(
      0,
      primary_hdr.Telemetry,
      False,
      0x55,
      primary_hdr.Unsegmented,
      0x00,
      0x00,
    )

  io.println(primary_hdr.to_string(space_packet_pri_hdr))

  let hdr_bin = primary_hdr.to_bit_array(space_packet_pri_hdr)

  use hdr_new <- result.map(primary_hdr.from_bit_array(hdr_bin))

  io.println("Is same: " <> bool.to_string(hdr_new == space_packet_pri_hdr))
  io.println("New Header:\n" <> primary_hdr.to_string(hdr_new))
}
